//  -
//        
//         =)
//
//              
//      ,    ,
//     .
//
// () Proteus


#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define DWORD unsigned long  // sizeof=4
#define BYTE unsigned char	// sizoef=1

#define TSIZE 100000

char text[TSIZE+1]; // 
char word[10];		//  
int count;			//   

// 
class FindRK{
	virtual int Find()=0;
};

//  
class Find1:FindRK{
public:
	int Find();
};

//   
class Find2:FindRK{
	friend Find1::Find();
	static DWORD Chc1(const char *text,size_t size);
	static BYTE Chc2(const char *text,size_t size);
public:
	int Find();
};

//    
class Find3:FindRK{
	DWORD Chc(const char *text,size_t size);
public:
	int Find();
};

//    - -   
class Find4:FindRK{
	DWORD dd;
	static const DWORD C;
	static const DWORD M;
	DWORD Chc(const char *text,size_t size);
	DWORD Update(DWORD,BYTE b0,BYTE bn);
public:
	int Find();
};

const DWORD Find4::C=239;		//   8 
const DWORD Find4::M=11883089;	//   23  (  )



int Find1::Find()
{
	size_t w_len,t_len; char *end,*ref;
	DWORD sum,sum0;
	t_len=strlen(text);
	w_len=strlen(word);
	count=0; t_len-=w_len;
	if(t_len<0) return -1;
	sum=Find2::Chc1(word,w_len);
	sum0=Find2::Chc1(text,w_len);
	end=text+t_len; ref=text;
	while(ref<=end) {
		if(sum==sum0) {
			count++;
			if(!strncmp(ref,word,w_len)) return ref-text;
		}
		sum0+=(BYTE)ref[w_len]-(BYTE)*ref;
		ref++;
	}
	return -1;
}


//     
DWORD Find2::Chc1(const char *text,size_t size)
{
	DWORD res=0;
	while(size--) res+=(BYTE)*text++;
	return res;
}


//  XOR   
BYTE Find2::Chc2(const char *text,size_t size)
{
	BYTE res=0;
	while(size--) res^=(BYTE)*text,text++;
	return res;
}


//  
int Find2::Find()
{
	size_t w_len,t_len; char *end,*ref; BYTE xr,xr0;
	DWORD sum,sum0;
	t_len=strlen(text);
	w_len=strlen(word);
	count=0; t_len-=w_len;
	if(t_len<0) return -1;
	sum=Chc1(word,w_len);  xr =Chc2(word,w_len);
	sum0=Chc1(text,w_len); xr0=Chc2(text,w_len);
	end=text+t_len; ref=text;
	while(ref<=end) {
		if(sum==sum0 && xr==xr0) {
			count++;
			if(!strncmp(ref,word,w_len)) return ref-text;
		}
		sum0+=(BYTE)ref[w_len]-(BYTE)*ref;
		xr0^=(BYTE)ref[w_len]^(BYTE)*ref;
		ref++;
	}
	return -1;
}


DWORD Find3::Chc(const char *text,size_t size)
{
	DWORD res=0;
	while(size--) res=_rotl(res,1)^(BYTE)*text++;
	return res;
}

int Find3::Find()
{
	DWORD sum,sum0; int w_len,t_len; char *end,*ref;
	t_len=strlen(text);
	w_len=strlen(word);
	t_len-=w_len; count=0;
	sum=Chc(word,w_len); sum0=Chc(text,w_len);
	end=text+t_len; ref=text;
	while(ref<=end) {
		if(sum==sum0) {
			count++;
			if(!strncmp(ref,word,w_len)) return ref-text;
		}
		sum0=_rotl(sum0,1)^(BYTE)ref[w_len];
		sum0^=_rotl((BYTE)ref[0],w_len%32);
		ref++;
	}
	return -1;
}


DWORD Find4::Chc(const char *text,size_t size)
{
	DWORD res=0; dd=1;
	while(size--) {
		dd=(dd*C)%M;
		res=(res*C+(BYTE)*text++)%M;
	}
	return res;
}

inline DWORD Find4::Update(DWORD sum,BYTE b0,BYTE bn)
{
	DWORD ss,t1,t2;
	ss=(DWORD)-dd*b0;
	ss+=(M-ss)/M*M;	
	//        (   )
	//       
	//	-   
	return (sum*C+ss+bn)%M;
}


int Find4::Find()
{
	DWORD sum,sum0; int w_len,t_len; char *end,*ref;
	t_len=strlen(text);
	w_len=strlen(word);
	t_len-=w_len; count=0;
	sum=Chc(word,w_len); sum0=Chc(text,w_len);
	end=text+t_len; ref=text;
	while(ref<=end) {
		if(sum==sum0) {
			count++;
			if(!strncmp(ref,word,w_len)) return ref-text;
		}
		sum0=Update(sum0,ref[0],ref[w_len]);
		ref++;
	}
	return -1;
}


int main()
{
	int n; srand(3);
	//    
	for(n=0; n<5    ; n++) word[n]=(rand()%7)+'a'; word[n]=0;
	for(n=0; n<TSIZE; n++) text[n]=(rand()%7)+'a'; text[n]=0;

	//         
	n=Find1().Find(); printf("Find1 - res: %d   count: %d\n",n,count);
	n=Find2().Find(); printf("Find2 - res: %d   count: %d\n",n,count);
	n=Find3().Find(); printf("Find3 - res: %d   count: %d\n",n,count);
	n=Find4().Find(); printf("Find4 - res: %d   count: %d\n",n,count);
	printf("[press enter]\n"); getchar();
	return 0;
}


